/**
 * This file is the main manager for languages.
 * Language files register themselves here.
 */
export interface LanguageDefinition {
    identifier: RegExp[];
    keyword: RegExp[];
    separator: RegExp[];
    operator: RegExp[];
    literals: {
        boolean: RegExp[];
        number: RegExp[];
        string: RegExp[];
        null: RegExp[];
    };
    comment: RegExp[];
}
export interface Language {
    name: string;
    defenition: LanguageDefinition;
}
export declare function registerLanguage(lang: Language): void;
export declare function getLanguages(): Language[];
